/****************************************************************************\

PSOProxy - http proxy server for the PSO web browser

Copyright (C) 2003 Adrian O'Grady and James Sutherland

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

\****************************************************************************/

// HttpHeader.h: interface for the CHttpHeader class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HTTPHEADER_H__BA77E143_1FD6_11D7_8A13_00104B7ED9DC__INCLUDED_)
#define AFX_HTTPHEADER_H__BA77E143_1FD6_11D7_8A13_00104B7ED9DC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "URL.h"
#include "Interfaces.h"

class CHttpHeader : public IHttpHeader
{
public:
	bool StartRequest(const char * Request);
	const char * GetValue(const char * Key);
	void AddHeader(const char * Header);
	CHttpHeader();
	virtual ~CHttpHeader();

	const char *		GetProtocol();
	const char *		GetHost();
	unsigned short		GetPort();
	const char *		GetPath();
	const char *		GetExtra();
	const char *		GetMethod();
	const char *		GetVersion();


private:
	CURL	m_URL;
	char	m_Method[16];
	char	m_Version[16];

private:
	struct kvpair
	{
		char	Key[64];
		char	Value[1024];
		kvpair *Next;
	};

	kvpair *m_Head;

private:
	const char * GetValue(const char* key, kvpair * Chain);
	void DestroyChain(kvpair * Chain);
	void AddPair(const char *Key, const char *Value, kvpair *& Chain);

};

#endif // !defined(AFX_HTTPHEADER_H__BA77E143_1FD6_11D7_8A13_00104B7ED9DC__INCLUDED_)
