/****************************************************************************\

PSOProxy - http proxy server for the PSO web browser

Copyright (C) 2003 Adrian O'Grady and James Sutherland

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

\****************************************************************************/

// MimeDB.cpp: implementation of the CMimeDB class.
//
//////////////////////////////////////////////////////////////////////

#include <string.h>
#include "MimeDB.h"
#include "Settings.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMimeDB CMimeDB::s_inst;

CMimeDB::CMimeDB()
{

}

CMimeDB::~CMimeDB()
{

}

const char * CMimeDB::GetType(const char *FileName)
{
	const char * Ext = GetFileExt(FileName);
	const char * type = CSettings::Get().GetValueAsString("Mime DB", Ext);

	if (type)
	{
		return type;
	}
	else
	{
		type = CSettings::Get().GetValueAsString("Mime DB", "default");
		if (type)
		{
			return type;
		}
		else
		{
			return "application/octet-stream";
		}
	}
}

const char * CMimeDB::GetFileExt(const char *FileName)
{
	unsigned int Position = strlen(FileName);

	while (Position > 0)
	{
		Position--;
		if (FileName[Position] == '.')
		{
			return &FileName[Position+1];
		}
	}

	return "";
}
