/****************************************************************************\

PSOProxy - http proxy server for the PSO web browser

Copyright (C) 2003 Adrian O'Grady and James Sutherland

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

\****************************************************************************/

// ProcessData.h: interface for the CProcessData class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROCESSDATA_H__EAEF8CA0_2027_11D7_8A13_00104B7ED9DC__INCLUDED_)
#define AFX_PROCESSDATA_H__EAEF8CA0_2027_11D7_8A13_00104B7ED9DC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define GC_FILE_SIZE 122880

class CProcessData  
{
public:

	CProcessData();
	virtual ~CProcessData();

	void OnData(const char * Data, unsigned int Length);
	void OnFile(const char * FileName);

	const char * GetFileName() { return m_pFileName; }

private:

	void ProcessDecodedData();

	char pTable[128];
	char pDecodedFile[GC_FILE_SIZE];
	SHORT pBitmap16[49152];	// 256*192
	char pBitmap24[147456];	// 256*192*3
	char m_pFileName[MAX_PATH];

	unsigned char pRedLookup[32];
	unsigned char pGreenLookup[64];
	unsigned char pBlueLookup[32];

	struct
	{
		int x;
		int y;
		float score;

	} pSmoothMask[8];

//	void Generate24BitValueNice(int x, int y, int& r, int& g, int& b);
	void Generate24BitValue(int x, int y, int sharp, int& r, int& g, int& b);

	void Decode(char *pIn, char *pOut, int count);
	void DecodeBytes(char pIn[4], char pOut[3]);
	inline int DecodeByte(char c) { return pTable[c&0x7f]&0x7f; }

	void GenerateBitmap();
	inline void SetCol16(int x, int y, SHORT col) { pBitmap16[x+256*y]=col; }
	inline SHORT GetCol16(int x, int y) { if(x<0 || x>255 || y<0 || y>191) return -1; return pBitmap16[x+256*y]; }
	void WriteBMP(const char *pFileName);
	void WritePNG(const char *pFileName);
};

#endif // !defined(AFX_PROCESSDATA_H__EAEF8CA0_2027_11D7_8A13_00104B7ED9DC__INCLUDED_)
