/****************************************************************************\

PSOProxy - http proxy server for the PSO web browser

Copyright (C) 2003 Adrian O'Grady and James Sutherland

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

\****************************************************************************/

// SaveFile.h: interface for the CSaveFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SAVEFILE_H__2DCFD0AC_1FFD_11D7_8A13_00104B7ED9DC__INCLUDED_)
#define AFX_SAVEFILE_H__2DCFD0AC_1FFD_11D7_8A13_00104B7ED9DC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Interfaces.h"
#include "ProcessData.h"

class CSaveFile : public IProxyApplet1
{
public:
	void OnProxyTag(int TagNumber);
	CSaveFile(IProxyAPI1& API);
	virtual ~CSaveFile();

	static IProxyApplet1* CreateApplet(IProxyAPI1& API);
	static void ReleaseApplet(IProxyApplet1 *Applet);

	int appmain(unsigned int argc, const char** argv);
	void terminate();

private:
	void ScanForFile();
	void SendThankYouPage();
	unsigned int m_ContentLength;
	unsigned int m_Saved;
	char * m_Data;

	CProcessData m_ProcessData;

	IProxyAPI1& m_API;
};

#endif // !defined(AFX_SAVEFILE_H__2DCFD0AC_1FFD_11D7_8A13_00104B7ED9DC__INCLUDED_)
