/****************************************************************************\

PSOProxy - http proxy server for the PSO web browser

Copyright (C) 2003 Adrian O'Grady and James Sutherland

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

\****************************************************************************/

// StreamToLine.cpp: implementation of the CStreamToLine class.
//
//////////////////////////////////////////////////////////////////////
#include <string.h>
#include <assert.h>
#include "StreamToLine.h"

#define		CRLF					"\x0D\x0A"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CStreamToLine::CStreamToLine(unsigned int BufferSize)
{
	LineBuffer = new char[BufferSize];
	LineBuffer[0] = 0;
}

CStreamToLine::~CStreamToLine()
{
	delete[] LineBuffer;
}

void CStreamToLine::StreamIn(const char *Data, unsigned int Length)
{
	unsigned int x = strlen(LineBuffer);
	// Copy the new data into the buffer
	memcpy(&LineBuffer[x], Data, Length);
	LineBuffer[x + Length] = 0;
}

void CStreamToLine::ShiftBuffer(char *NewStart)
{
	unsigned int x = 0;

	assert(LineBuffer < NewStart);

	while (NewStart[x] != 0)
	{
		LineBuffer[x] = NewStart[x];
		x++;
	}

	LineBuffer[x] = 0;
}

char * CStreamToLine::GetLine(char *Output)
{
	char * Found = 0;
	char * RetVal = 0;

	// Now to see if we have a new line
	Found = strstr(LineBuffer, CRLF);

	if (Found != 0)
	{
		RetVal = Output;
		memcpy(RetVal, LineBuffer, (Found - LineBuffer));
		RetVal[Found - LineBuffer] = 0;

		// The data located after the CRFL should me moved to the start of the buffer
		ShiftBuffer(Found + 2);
	}

	return RetVal;
}
