/****************************************************************************\

PSOProxy - http proxy server for the PSO web browser

Copyright (C) 2003 Adrian O'Grady and James Sutherland

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

\****************************************************************************/

// URL.cpp: implementation of the CURL class.
//
//////////////////////////////////////////////////////////////////////

#include <string.h>
#include <stdlib.h>
#include "URL.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CURL::CURL()
{
	m_Protocol[0] = 0;
	m_Host[0] = 0;
	m_Port = 0;
	m_Path[0] = 0;
	m_Extra[0] = 0;
}

CURL::~CURL()
{

}

void CURL::ParseURL(const char *URL)
{
	char * urlBuffer = new char[strlen(URL) + 1];
	char * Found = 0;
	char * NextStart = 0;

	strcpy(urlBuffer, URL);

	// First find the protocol
	Found = strstr(urlBuffer, "://");
	if (Found)
	{
		memcpy(m_Protocol, urlBuffer, (Found - urlBuffer));
		m_Protocol[(Found - urlBuffer)] = 0;
		// Move on to the host
		NextStart = Found + 3;
	}
	else
	{
		// No protocol specified, just assume http
		strcpy(m_Protocol, "http");
		NextStart = urlBuffer;
	}

	// Now to find the path
	Found = strstr(NextStart, "/");
	if (Found)
	{
		// Is there any extra data?
		char * Extra = strstr(Found, "?");
		if (Extra)
		{
			strcpy(m_Extra, Extra+1);
			*Extra = 0; // Kill off the extra data
		}

		// Now to copy the path
		strcpy(m_Path, Found);
		*Found = 0; // Kill off the path


	}
	else
	{
		// No path specified, assume it to be /
		strcpy(m_Path, "/");
	}

	// Get the port port
	Found = strstr(NextStart, ":");
	if (Found)
	{
		// A port has been set
		m_Port = (unsigned short)atoi(Found+1);
		*Found = 0; // Kill of the port
	}
	else
	{
		// Assume port 80
		m_Port = 80;
	}

	// Finally, get the host
	strcpy(m_Host, NextStart);

	delete[] urlBuffer;
}
