// VirtualPathMan.h: interface for the CVirtualPathMan class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VIRTUALPATHMAN_H__5D47381D_7F6F_4F45_B52F_80E7695CC007__INCLUDED_)
#define AFX_VIRTUALPATHMAN_H__5D47381D_7F6F_4F45_B52F_80E7695CC007__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "interfaces.h"

class CVirtualPathMan  : public ISettingsEnumerator
{
public:
	void LoadVirtualPaths();
	char * GetRealPath(const char * Path, char * Output);
	static CVirtualPathMan& Get()		{ return s_inst; }
	virtual ~CVirtualPathMan();

	void OnDataItem(const char * Key, const char * Value, bool LastItem);

private:
	char * GetRealVirtualPath(const char *Path, char *Output);
	CVirtualPathMan();
	static CVirtualPathMan s_inst;

	
	struct sPath
	{
		char VirtualPath[256];
		char RealPath[512];
	};

	int		m_NumVirtualPaths;
	sPath	m_PathList[64];

};

#endif // !defined(AFX_VIRTUALPATHMAN_H__5D47381D_7F6F_4F45_B52F_80E7695CC007__INCLUDED_)
