/****************************************************************************\

PSOProxy - http proxy server for the PSO web browser

Copyright (C) 2003 Adrian O'Grady and James Sutherland

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

\****************************************************************************/

// AppletDB.h: interface for the CAppletDB class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_APPLETDB_H__9565DEC2_7F13_4992_AC99_146F72D63DFD__INCLUDED_)
#define AFX_APPLETDB_H__9565DEC2_7F13_4992_AC99_146F72D63DFD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Interfaces.h"
#include "ProxyAPI1.h"

class CAppletDB  
{
public:
	struct AppletArgs
	{
		int				Socket;
		CHttpHeader *	Header;
		unsigned int	BufferedInputLength;
		const char *	BufferedInput;
		unsigned int	argc;
		const char **	argv;
	};
	
public:
	bool IsApplet(const char * AppletName);
	void LoadDB();
	int ExecApplet(const char *AppletName, const char *Args, CProxyAPI1 * Parent);
	int ExecApplet(const char * Name, AppletArgs Args);
	static CAppletDB& Get()	{ return s_inst; }
	virtual ~CAppletDB();

private:
	struct sAppletCallbacks
	{
		char AppletName[32];
		IProxyApplet1 *(*CreateApplet)(IProxyAPI1& API);
		void (*ReleaseApplet)(IProxyApplet1 *Applet);
	};

	sAppletCallbacks *	m_AppletList;
	unsigned int		m_AppletCount;

private:
	CAppletDB();
	static CAppletDB s_inst;
	sAppletCallbacks * GetApplet(const char * Name);
};

#endif // !defined(AFX_APPLETDB_H__9565DEC2_7F13_4992_AC99_146F72D63DFD__INCLUDED_)
