// ProxyAPI1.h: interface for the CProxyAPI1 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROXYAPI1_H__EE4D90CA_3102_463D_B697_2B46D63E1163__INCLUDED_)
#define AFX_PROXYAPI1_H__EE4D90CA_3102_463D_B697_2B46D63E1163__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <windows.h>
#include <winsock.h>
#include "HttpHeader.h"
#include "Interfaces.h"

class CAppletDB;

class CProxyAPI1 : public IProxyAPI1  
{
friend class CAppletDB;

public:
	bool SendDynamicPage(const char * Filename);
	void SetOwner(IProxyApplet1 * Owner);
	void GetServerVersion(int& Major, int& Minor, int& Revision);
	const char * GetServerVersionString();
	static void StaticDeinitialise();
	static bool StaticInitialise();
	void GetAllSettings(ISettingsEnumerator * callback);
	void SetSetting(const char *Key, int Value);
	void SetSetting(const char *Key, float Value);
	void SetSetting(const char *Key, const char *Value);
	bool SendPage(const char *Filename);
	void SendInternalError(const char *Error);
	void SendHeader(const char *Result, const char *ContentType, unsigned int ContentLength, const char *Extra);
	int Send(const char *Data, int Length);
	int Recv(char *Data, int Length);
	void Log(const char *Text);
	const char * GetSettingAsString(const char *Key, const char *Default);
	int GetSettingAsInt(const char *Key, int Default);
	float GetSettingAsFloat(const char *Key, float Default);
	IHttpHeader& GetHttpHeader();
	int ExecApplet(const char * AppletName, const char * Args);
	CProxyAPI1();
	virtual ~CProxyAPI1();

protected:
	SOCKET			m_Socket;
	char			m_AppName[32];
	CHttpHeader *	m_Header;

	CProxyAPI1 *	m_Parent;
	IProxyApplet1 *	m_Owner;

	char *			m_BufInput;
	int				m_BufInputLen;

private:
	char * CopyNumber(const char * Text, char * Number);
	static HANDLE	m_LogSemaphore;
	static HANDLE	m_SettingsSemaphore;
};

#endif // !defined(AFX_PROXYAPI1_H__EE4D90CA_3102_463D_B697_2B46D63E1163__INCLUDED_)
